<?php
declare (strict_types = 1);

namespace app\command;

use think\console\Command;
use think\console\Input;
use think\console\input\Argument;
use think\console\input\Option;
use think\console\Output;
use think\facade\Db;

class Contrab extends Command
{
    protected function configure()
    {
        // 指令配置
        $this->setName('app\command\contrab')->setDescription('检测订阅 服务器');
    }

    protected function execute(Input $input, Output $output)
    {
        $sys = Db::table('vm_sys')->where('id', 1)->find();
        $sys = json_decode($sys['az'], true);
        if($sys['sub'] == true){
            if(!empty($sys['sub_stime'])){
                if($sys['sub_stime']+($sys['sub_time']*60) < time()){
                    $output->writeln('订阅 -> 开始检测');
                    sub();
                    $sys['sub_stime'] = time();
                }else{
                    $output->writeln('订阅 -> 未到检测时间 -> 剩余 '.ti($sys['sub_stime']+($sys['sub_time']*60) - time()));
                }
            }else{
                $output->writeln('订阅 -> 开始检测');
                sub();
                $sys['sub_stime'] = time();
            }
        }else{
            $output->writeln('订阅 -> 检测未开启');
        }
        
        if($sys['ser'] == true){
            if(!empty($sys['ser_stime'])){
                if($sys['ser_stime']+($sys['ser_time']*60) < time()){
                    $output->writeln('服务器 -> 开始检测');
                    ser();
                    $sys['ser_stime'] = time();
                }else{
                    $output->writeln('服务器 -> 未到检测时间 -> 剩余 '.ti($sys['ser_stime']+($sys['ser_time']*60) - time()));
                }
            }else{
                $output->writeln('服务器 -> 开始检测');
                ser();
                $sys['ser_stime'] = time();
            }
        }else{
            $output->writeln('服务器 -> 检测未开启');
        }
        

        Db::table('vm_sys')->where('id', 1)->save(["az" => json_encode($sys)]);
    }
}

function ti($sj){
    $i = floor($sj / 60);
    $s = $sj % 60;
    return "$i:$s";
}