<?php
namespace app\controller;

use app\BaseController;
use think\facade\Request;
use think\facade\Db;

class Api extends BaseController
{
    public function initialize(){
        $url = Request::url();
        $urls = explode("/", $url);
        global $au, $aun, $auid, $url, $data, $aips;
        $url = end($urls);
        $data = Request::post();
        $auth = Request::header('Authorization');
        if(strlen($auth) != 32){
            exit(json_encode(['code'=> 10200, 'msg'=> '请重新登录']));
        }

        $user = Db::table('vm_az_user')->where('token', $auth)->find();
        if($user){
            $au = 'user';
            $aun = $user['name'];
            $auid = $user['id'];
            $aips = $user['ips'];
            return;
        }else{
            $user = Db::table('vm_sys')->where('id',1)->find();
            if($auth == $user['token']){
                $au = 'admin';
                $aun = $user['name'];
                $auid = $user['id'];
                $aips = true;
                return;
            }
        }
        exit(json_encode(['code'=> 10200, 'msg'=> '请重新登录']));
    }

    public function userInfo()
    {
        global $au, $aun;
        if($au == 'admin'){
            return json(['code'=> 200, 'msg'=> 'success', 'data'=> [
                            'permissions'=> ['admin'],
                            'username'=> $aun,
                            'avatar'=> 'https://i.gtimg.cn/club/item/face/img/2/15922_100.gif',]
                        ]);
        }else if($au == 'user'){
            return json(['code'=> 200, 'msg'=> 'success', 'data'=> [
                'permissions'=> ['user'],
                'username'=> $aun,
                'avatar'=> 'https://i.gtimg.cn/club/item/face/img/2/15922_100.gif',]
            ]);
        }else{
            return json(['code'=> 10200, 'msg'=>'error']);
        }
    }

    public function logout()
    {
        return json(['code'=> 200, 'msg'=>'success']);
    }

    public function user()
    {
        global $au, $aun, $url, $data;
        if($au != 'admin'){
            return json(['code'=> 10200, 'msg'=> '请重新登录']);
        }

        if($url == 'list'){
            $conut = Db::table('vm_az_user')->count();
            if(!empty($data['pageNo'])){
                $user = Db::table('vm_az_user')->limit(($data['pageNo']-1)*$data['pageSize'],$data['pageSize'])->order('id desc')->select();
            }else{
                $user = Db::table('vm_az_user')->where('status', 1)->order('id desc')->select();
            }
            
            return json(['code'=> 200, 'msg'=> 'success', 'totalCount'=> $conut, 'data'=> $user]);
        }
        
        if($url == 'add'){
            $data['name'] = $data['username'];
            $data['pass'] = md5($data['password']);
            unset($data['username']);
            unset($data['password']);
            $user = Db::table('vm_az_user')->where('name', $data['name'])->find();
            if(!$user){
                if(Db::table('vm_az_user')->insert($data)){
                    return json(['code'=> 200, 'msg'=>'添加成功']);
                }else{
                    return json(['code'=> 500, 'msg'=>'添加失败']);
                }
            }
            return json(['code'=> 500, 'msg'=>'用户名已存在']);
        }
        
        if($url == 'edit'){
            if(!empty($data['password'])){
                $data['pass'] = md5($data['password']);
                unset($data['password']);
            }
            if(Db::table('vm_az_user')->where('id', $data['id'])->save($data)){
                return json(['code'=> 200, 'msg'=>'修改成功']);
            }else{
                return json(['code'=> 500, 'msg'=>'修改失败']);
            }
        }
        
        if($url == 'del'){
            if(Db::table('vm_az_user')->where('id', $data['id'])->delete()){
                Db::name('vm_az_sub')->where('user', $data['id'])->update(['user'=>null]);
                return json(['code'=> 200, 'msg'=>'删除成功']);
            }else{
                return json(['code'=> 500, 'msg'=>'删除失败']);
            }
        }
        
        if($url == 'whmcs'){
            $token = md5(time());
            if(Db::table('vm_az_user')->where('id', $data['id'])->update(['whmcs'=>$token])){
                return json(['code'=> 200, 'msg'=>$token]);
            }else{
                return json(['code'=> 500, 'msg'=>'whmcs 创建失败']);
            }
        }
    }

    public function sub()
    {
        global $au, $aun, $auid, $url, $data;
        $where = [];
        if($au != 'admin'){
            $where['user'] = $auid;
        }

        if($url == 'list'){
            if(!empty($data['id'])){
                $where['user'] = $data['id'];
            }
            $conut = Db::table('vm_az_sub')->where($where)->count();
            if(!empty($data['pageNo'])){
                $user = Db::table('vm_az_sub')->where($where)->limit(($data['pageNo']-1)*$data['pageSize'],$data['pageSize'])->order('id desc')->select()->toArray();
            }else{
                $user = Db::table('vm_az_sub')->where($where)->where('status', 'Enabled')->order('id desc')->select()->toArray();
            }
            foreach ($user as $key => $value) {
                // if($au != 'admin'){
                //     unset($user[$key]['json']);
                //     unset($user[$key]['client_id']);
                //     unset($user[$key]['client_secret']);
                //     unset($user[$key]['tenant_id']);
                //     unset($user[$key]['subscription_id']);
                // }
                if($value['user'] > 0){
                    $us = Db::table('vm_az_user')->where('id',$value['user'])->find();
                    $user[$key]['user'] = $us['id'];
                    $user[$key]['username'] = $us['name'];
                }
			}

            return json(['code'=> 200, 'msg'=> 'success', 'totalCount'=> $conut, 'data'=> $user]);
        }
        
        if($url == 'add'){
            if($au != 'admin'){
                $userid = $auid;
                $user = Db::table('vm_az_user')->where('id', $userid)->find();
                if($user['dy'] != 1){
                    return json(['code'=> 500, 'msg'=>'无权添加订阅']);
                }
            }else{
                $userid = $data['user'];
            }

            $json = json_decode($data['json1'], true);
            if(!empty($json['clientId']) && empty($json['appId'])){
                $json['appId'] = $json['clientId'];
            }
            if(!empty($json['clientSecret']) && empty($json['password'])){
                $json['password'] = $json['clientSecret'];
            }
            if(!empty($json['tenantId']) && empty($json['tenant'])){
                $json['tenant'] = $json['tenantId'];
            }
            
            $sub = json_decode(post("az_global", 'sub_id', $json), true);
            if($sub['code'] == 200){
                if(count($sub['data']) < 1){
                    return json(['code'=> 500, 'msg'=>'无可用订阅']);
                }
                foreach($sub['data'] as $v){
                    $v['name'] = $data['name'];
                    $v['user'] = $userid;
                    Db::name('vm_az_user')->where('id', $userid)->inc('sub')->update();
                    $v['json'] = $data['json1'];
                    $v['status'] = 'Enabled';
                    $v['client_id'] = $json['appId'];
                    $v['client_secret'] = $json['password'];
                    $v['tenant_id'] = $json['tenant'];
                    $v['bz'] = $data['bz'];
                    $vm = $v['vm'];
                    unset($v['vm']);
                    $subid = Db::table('vm_az_sub')->insertGetId($v);
                    foreach($vm as $vv){
                        $vv['sub'] = $subid;
                        Db::table('vm_az_ser')->insert($vv);
                    }
                    return json(['code'=> 200, 'msg'=>'添加成功']);
                }
            }
            return json(['code'=> 500, 'msg'=>'后端获取失败']);
        }
        
        if($url == 'edit'){
            $sub = Db::table('vm_az_sub')->where($where)->where('id', $data['id'])->find();
            if(!empty($sub['user'])){
                Db::name('vm_az_user')->where('id', $sub['user'])->dec('sub')->update();
            }
            if($au != 'admin'){
                $data['user'] = $auid;
            }
            
            if(Db::table('vm_az_sub')->where($where)->where('id', $data['id'])->save($data)){
                if(!empty($data['user'])){
                    Db::name('vm_az_user')->where('id', $data['user'])->inc('sub')->update();
                }
                return json(['code'=> 200, 'msg'=>'修改成功']);
            }else{
                return json(['code'=> 500, 'msg'=>'修改失败']);
            }
        }
        
        if($url == 'del'){
            $sub = Db::table('vm_az_sub')->where($where)->where('id', $data['id'])->find();
            if(!empty($sub['user'])){
                Db::name('vm_az_user')->where('id', $sub['user'])->dec('sub')->update();
            }
            if(Db::table('vm_az_sub')->where($where)->where('id', $data['id'])->delete()){
                Db::table('vm_az_ser')->where($where)->where('sub', $data['id'])->delete();
                return json(['code'=> 200, 'msg'=>'删除成功']);
            }else{
                return json(['code'=> 500, 'msg'=>'删除失败']);
            }
        }
    }

    public function server()
    {
        global $au, $aun, $auid, $url, $data, $aips;
        $where = [];

        if($url == 'list'){
            if($au == 'admin'){
                $conut = Db::table('vm_az_ser')->count();
                if(!empty($data['id'])){
                    $where['sub'] = $data['id'];
                }
                $conut = Db::table('vm_az_ser')->where($where)->count();
                if($data['pageNo']){
                    $user = Db::table('vm_az_ser')->where($where)->limit(($data['pageNo']-1)*$data['pageSize'],$data['pageSize'])->order('id desc')->select()->toArray();
                }else{
                    $user = Db::table('vm_az_ser')->where($where)->order('id desc')->select()->toArray();
                }
            }else{
                if(!empty($data['id'])){
                    $sub = Db::table('vm_az_sub')->where('user', $auid)->where('id', $data['id'])->find();
                    if(!$sub){
                        return json(['code'=> 500, 'msg'=>'无权操作该订阅']);
                    }
                    if(!empty($data['id'])){
                        $where['sub'] = $data['id'];
                    }
                    $conut = Db::table('vm_az_ser')->where($where)->count();
                    if($data['pageNo']){
                        $user = Db::table('vm_az_ser')->where($where)->limit(($data['pageNo']-1)*$data['pageSize'],$data['pageSize'])->order('id desc')->select()->toArray();
                    }else{
                        $user = Db::table('vm_az_ser')->where($where)->order('id desc')->select()->toArray();
                    }
                }else{
                    $conut = Db::table('vm_az_ser')->where('user', $auid)->count();
                    $user = Db::table('vm_az_ser')->where('user', $auid)->limit(($data['pageNo']-1)*$data['pageSize'],$data['pageSize'])->order('id desc')->select()->toArray();
                }
            }
        
            foreach ($user as $key => $value) {
                if($value['user'] > 0){
                    $us = Db::table('vm_az_user')->where('id',$value['user'])->find();
                    if($us){
                        $user[$key]['user'] = $us['name'];
                        $user[$key]['username'] = $us['name'];
                    }else{
                        $user[$key]['user'] = "用户不存在";
                        $user[$key]['username'] = "用户不存在";
                    }
                }
                $us = Db::table('vm_az_sub')->where('id',$value['sub'])->find();
                if($us){
                    $user[$key]['sub_id'] = $us['id'];
                    $user[$key]['sub_name'] = $us['name'];
                    $user[$key]['sub_status'] = $us['status'];
                }else{
                    $user[$key]['sub_name'] = "订阅不存在";
                    $user[$key]['sub_status'] = "null";
                }
			}

            return json(['code'=> 200, 'msg'=> 'success', 'totalCount'=> $conut, 'data'=> $user, 'add'=> 'add']);
        }
        
        if($au != 'admin'){
            $where['user'] = "$auid";
            $data['user'] = "$auid";
        }

        if($url == 'add'){
            $sub = Db::table('vm_az_sub')->where($where)->where('id',$data['sub'])->find();
            if(!$sub){
                return json(['code'=> 500, 'msg'=>'无权操作该订阅']);
            }
            for ($i=1; $i<=$data['sl']; $i++){
                $tag = time()."-".$i;
                $ser = [];
                $ser['name'] = $data['name'];
                $ser['tag'] = $tag;
                $ser['gro'] = $tag;
                $ser['sub'] = $data['sub'];
                $ser['bz'] = $data['bz'];
                $ser['status'] = '创建中';
                $serid = Db::table('vm_az_ser')->insertGetId($ser);
                
                $json = $data;
                $json['serid'] = $serid;
                $json['tag'] = $tag;
                $json['client_id'] = $sub['client_id'];
                $json['client_secret'] = $sub['client_secret'];
                $json['tenant_id'] = $sub['tenant_id'];
                $json['subscription_id'] = $sub['subscription_id'];
                // return json(['code'=> 500, 'msg'=>$json]);
                post("az_global", 'ser_add', $json);
            }
            return json(['code'=> 200, 'msg'=>'后台创建中']);
        }
        
        if($url == 'edit'){
            if(Db::table('vm_az_ser')->where($where)->where('id', $data['id'])->save($data)){
                return json(['code'=> 200, 'msg'=>'修改成功']);
            }else{
                return json(['code'=> 500, 'msg'=>'修改失败']);
            }
        }
        
        if($url == 'clear'){
            $sub = Db::table('vm_az_sub')->where($where)->where('id', $data['id'])->find();
            if(!$sub){
                return json(['code'=> 500, 'msg'=>'无权操作该订阅']);
            }
            post("az_global", 'ser_clear', $sub);
            return json(['code'=> 200, 'msg'=>'后台清理中']);
        }
        
        if($url == 'del'){
            if(strpos($data['id'],',')){
                $ids = explode(',',$data['id']);
            }else{
                $ids = [$data['id']];
            }
            foreach ($ids as $id){
                $ser = Db::table('vm_az_ser')->where('id', $id)->find();
                $sub = Db::table('vm_az_sub')->where($where)->where('id',$ser['sub'])->find();
                if(!$sub){
                    $sub = Db::table('vm_az_sub')->where('id',$ser['sub'])->find();
                    if($sub){
                        return json(['code'=> 500, 'msg'=>'无权操作该订阅']);
                    }else{
                        Db::table('vm_az_ser')->where('id', $id)->delete();
                        return json(['code'=> 200, 'msg'=>'订阅已不存在，成功删除服务器记录']);
                    }
                }
                Db::table('vm_az_ser')->where('id', $ser['id'])->save(['status'=> '正在删除']);
                $json = $ser;
                $json['client_id'] = $sub['client_id'];
                $json['client_secret'] = $sub['client_secret'];
                $json['tenant_id'] = $sub['tenant_id'];
                $json['subscription_id'] = $sub['subscription_id'];
                post("az_global", 'ser_del', $json);
            }
            return json(['code'=> 200, 'msg'=>'后台删除中']);
        }
        
        if($url == 'vm'){
            $ser = Db::table('vm_az_ser')->where('id', $data['id'])->find();
            $sub = Db::table('vm_az_sub')->where('id', $ser['sub'])->find();
            if($au != 'admin'){
                if(!($ser['user'] == $auid || $sub['user'] == $auid)){
                    return json(['code'=> 500, 'msg'=>'无权操作该服务器']);
                }
            }
            $json = $ser;
            $json['cz'] = $data['type'];
            if(substr($json['cz'],0,5) == "delip"){
                $cz = explode("-", $json['cz']);
                if(count($cz) == 2){
                    $json['cz'] = $cz[0];
                    $json['ip'] = $cz[1];
                }
            }

            if($json['cz'] == "delip" || $json['cz'] == "addip" || $json['cz'] == "addips"){
                if(!$aips){
                    return json(['code'=> 500, 'msg'=>'无权操作辅助 IP']);
                }
            }
            $d = Db::table('vm_az_data')->where('name',$json['tag'])->where('type',2)->find();
            if($d && $json['cz'] != "status"){
                $sys = Db::table('vm_sys')->where('id', 1)->find();
                $sys = json_decode($sys['az'], true);
                if(time()-$d['data'] < $sys['start_time']*60*60){
                    return json(['code'=> 500, 'msg'=> '未到可开机时间，不可操作']);
                }
            }

            $json['sub_id'] = $sub['id'];
            $json['client_id'] = $sub['client_id'];
            $json['client_secret'] = $sub['client_secret'];
            $json['tenant_id'] = $sub['tenant_id'];
            $json['subscription_id'] = $sub['subscription_id'];
            $re = json_decode(post("az_global", 'ser_vm', $json), true);
            if(!empty($re['msg']['ip'])){
                $u['ip'] = $re['msg']['ip'];
                $u['status'] = $re['msg']['status'];
                $ser = Db::table('vm_az_ser')->where('id', $data['id'])->save($u);
            }
            return json($re);
        }
    }

    public function sys()
    {
        global $au, $aun, $url, $data;
        if($au != 'admin'){
            return json(['code'=> 10200, 'msg'=> '请重新登录']);
        }
        if($url == 'get'){
            $sys = Db::table('vm_sys')->where('id',1)->find();
            unset($sys['pass']);
            $sys['check'] = $sys['az'];
            unset($sys['az']);
            $sys['user'] = $sys['name'];
            $sys['ver'] = "1.0.1";
            return json(['code'=> 200, 'msg'=> 'success', 'data'=> $sys]);
        }
        
        if($url == 'edit'){
            $data['name'] = $data['user'];
            $data['az'] = $data['check'];
            if(!empty($data['passw'])){
                $data['pass'] = md5($data['passw']);
                unset($data['passw']);
            }
            unset($data['user']);
            unset($data['check']);
            if(Db::table('vm_sys')->where('id', 1)->save($data)){
                return json(['code'=> 200, 'msg'=>'修改成功']);
            }else{
                return json(['code'=> 500, 'msg'=>'修改失败，可能无修改值']);
            }
        }
        
        if($url == 'sub'){
            sub();
            return json(['code'=> 200, 'msg'=>'后台检测订阅中...']);
        }
        
        if($url == 'ser'){
            ser();
            return json(['code'=> 200, 'msg'=>'后台检测服务器中...']);
        }
    }

    public function log()
    {
        global $au, $aun, $url, $data;
        if($au != 'admin'){
            return json(['code'=> 10200, 'msg'=> '请重新登录']);
        }
        if($url == 'list'){
            $conut = Db::table('vm_az_log')->count();
            $log = Db::table('vm_az_log')->limit(($data['pageNo']-1)*$data['pageSize'],$data['pageSize'])->order('id desc')->select()->toArray();

            return json(['code'=> 200, 'msg'=> 'success', 'totalCount'=> $conut, 'data'=> $log]);
        }
    }
}